<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::timer_heavy&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1timer__heavy.html">timer_heavy</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1timer__heavy-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::timer_heavy&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a05d39f8c24921da74b1f662a118c4e0b"><td class="memItemLeft" align="right" valign="top">typedef void(T::*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1timer__heavy.html#a05d39f8c24921da74b1f662a118c4e0b">af_type</a>) ()</td></tr>
<tr class="separator:a05d39f8c24921da74b1f662a118c4e0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a601bd476874c1546b00100f75abe7781"><td class="memItemLeft" align="right" valign="top"><a id="a601bd476874c1546b00100f75abe7781"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>timer_heavy</b> (T &amp;ao_, <a class="el" href="classdlib_1_1timer__heavy.html#a05d39f8c24921da74b1f662a118c4e0b">af_type</a> af_)</td></tr>
<tr class="separator:a601bd476874c1546b00100f75abe7781"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad7bfb75dbea032f402af2835de750c0"><td class="memItemLeft" align="right" valign="top"><a id="aad7bfb75dbea032f402af2835de750c0"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:aad7bfb75dbea032f402af2835de750c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5156e1df6142691e431565e784b854fc"><td class="memItemLeft" align="right" valign="top"><a id="a5156e1df6142691e431565e784b854fc"></a>
<a class="el" href="classdlib_1_1timer__heavy.html#a05d39f8c24921da74b1f662a118c4e0b">af_type</a>&#160;</td><td class="memItemRight" valign="bottom"><b>action_function</b> () const</td></tr>
<tr class="separator:a5156e1df6142691e431565e784b854fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a4c3326a82bb5e68b145be118af0cf6"><td class="memItemLeft" align="right" valign="top"><a id="a8a4c3326a82bb5e68b145be118af0cf6"></a>
const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>action_object</b> () const</td></tr>
<tr class="separator:a8a4c3326a82bb5e68b145be118af0cf6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0c2a477fd70ab4b07cceff2b5d5f4d5"><td class="memItemLeft" align="right" valign="top"><a id="ad0c2a477fd70ab4b07cceff2b5d5f4d5"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>action_object</b> ()</td></tr>
<tr class="separator:ad0c2a477fd70ab4b07cceff2b5d5f4d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afdc066e94effe2cd83c8f42565e05900"><td class="memItemLeft" align="right" valign="top"><a id="afdc066e94effe2cd83c8f42565e05900"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_running</b> () const</td></tr>
<tr class="separator:afdc066e94effe2cd83c8f42565e05900"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af13620791ad2e3f6d5195c0d116f77c5"><td class="memItemLeft" align="right" valign="top"><a id="af13620791ad2e3f6d5195c0d116f77c5"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>delay_time</b> () const</td></tr>
<tr class="separator:af13620791ad2e3f6d5195c0d116f77c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e75e6ece827ce17aec50f00ae111b0a"><td class="memItemLeft" align="right" valign="top"><a id="a0e75e6ece827ce17aec50f00ae111b0a"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_delay_time</b> (unsigned long milliseconds)</td></tr>
<tr class="separator:a0e75e6ece827ce17aec50f00ae111b0a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a53087e8225e9bf709a10d4ebf0fa8e4d"><td class="memItemLeft" align="right" valign="top"><a id="a53087e8225e9bf709a10d4ebf0fa8e4d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>start</b> ()</td></tr>
<tr class="separator:a53087e8225e9bf709a10d4ebf0fa8e4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1941981a6bc3796acf1ab06a247dac9"><td class="memItemLeft" align="right" valign="top"><a id="ac1941981a6bc3796acf1ab06a247dac9"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>stop</b> ()</td></tr>
<tr class="separator:ac1941981a6bc3796acf1ab06a247dac9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa127b16ee91b3e15a594c8a49e79bd43"><td class="memItemLeft" align="right" valign="top"><a id="aa127b16ee91b3e15a594c8a49e79bd43"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>stop_and_wait</b> ()</td></tr>
<tr class="separator:aa127b16ee91b3e15a594c8a49e79bd43"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:ab986e7890964b62987fc7e6cda33cfec"><td class="memItemLeft" align="right" valign="top"><a id="ab986e7890964b62987fc7e6cda33cfec"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>thread</b> ()</td></tr>
<tr class="separator:ab986e7890964b62987fc7e6cda33cfec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbaab2c7475eab1a2e19a70133047795"><td class="memItemLeft" align="right" valign="top"><a id="adbaab2c7475eab1a2e19a70133047795"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>timer_heavy</b> (const <a class="el" href="classdlib_1_1timer__heavy.html">timer_heavy</a>&lt; T &gt; &amp;)</td></tr>
<tr class="separator:adbaab2c7475eab1a2e19a70133047795"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad13cc2815a61a701c20542c8feb3324c"><td class="memItemLeft" align="right" valign="top"><a id="ad13cc2815a61a701c20542c8feb3324c"></a>
<a class="el" href="classdlib_1_1timer__heavy.html">timer_heavy</a>&lt; T &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classdlib_1_1timer__heavy.html">timer_heavy</a>&lt; T &gt; &amp;)</td></tr>
<tr class="separator:ad13cc2815a61a701c20542c8feb3324c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:ab4a92bd402f4da20fde17233ce8a75e7"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1timer__heavy.html#ab4a92bd402f4da20fde17233ce8a75e7">ao</a></td></tr>
<tr class="separator:ab4a92bd402f4da20fde17233ce8a75e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a505d06c7a98de847e3d5e74dce9d7c70"><td class="memItemLeft" align="right" valign="top"><a id="a505d06c7a98de847e3d5e74dce9d7c70"></a>
const <a class="el" href="classdlib_1_1timer__heavy.html#a05d39f8c24921da74b1f662a118c4e0b">af_type</a>&#160;</td><td class="memItemRight" valign="bottom"><b>af</b></td></tr>
<tr class="separator:a505d06c7a98de847e3d5e74dce9d7c70"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6434f27b7188fd502aa803fe9c2ccdc0"><td class="memItemLeft" align="right" valign="top"><a id="a6434f27b7188fd502aa803fe9c2ccdc0"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>delay</b></td></tr>
<tr class="separator:a6434f27b7188fd502aa803fe9c2ccdc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a10f932c99b62f59dd50078dbcd5efd7c"><td class="memItemLeft" align="right" valign="top"><a id="a10f932c99b62f59dd50078dbcd5efd7c"></a>
<a class="el" href="classdlib_1_1mutex.html">mutex</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m</b></td></tr>
<tr class="separator:a10f932c99b62f59dd50078dbcd5efd7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac238afe6c73f5786e4de0ddc31f487cb"><td class="memItemLeft" align="right" valign="top"><a id="ac238afe6c73f5786e4de0ddc31f487cb"></a>
<a class="el" href="classdlib_1_1signaler.html">signaler</a>&#160;</td><td class="memItemRight" valign="bottom"><b>s</b></td></tr>
<tr class="separator:ac238afe6c73f5786e4de0ddc31f487cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab6446e9497df69d5febb258208d51eea"><td class="memItemLeft" align="right" valign="top"><a id="ab6446e9497df69d5febb258208d51eea"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>running</b></td></tr>
<tr class="separator:ab6446e9497df69d5febb258208d51eea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a18924a0076d5ffe52a3fe1839859ce"><td class="memItemLeft" align="right" valign="top"><a id="a0a18924a0076d5ffe52a3fe1839859ce"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>stop_running</b></td></tr>
<tr class="separator:a0a18924a0076d5ffe52a3fe1839859ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d5b943c04a8613ce89918bab5d06fd0"><td class="memItemLeft" align="right" valign="top"><a id="a6d5b943c04a8613ce89918bab5d06fd0"></a>
<a class="el" href="classdlib_1_1timestamper.html">timestamper</a>&#160;</td><td class="memItemRight" valign="bottom"><b>ts</b></td></tr>
<tr class="separator:a6d5b943c04a8613ce89918bab5d06fd0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a922fa5f9c4dddfcae910a62faf6a999c"><td class="memItemLeft" align="right" valign="top"><a id="a922fa5f9c4dddfcae910a62faf6a999c"></a>
<a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>&#160;</td><td class="memItemRight" valign="bottom"><b>next_time_to_run</b></td></tr>
<tr class="separator:a922fa5f9c4dddfcae910a62faf6a999c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a05d39f8c24921da74b1f662a118c4e0b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a05d39f8c24921da74b1f662a118c4e0b">&#9670;&nbsp;</a></span>af_type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef void(T::* <a class="el" href="classdlib_1_1timer__heavy.html">dlib::timer_heavy</a>&lt; T &gt;::af_type) ()</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">WHAT THIS OBJECT REPRESENTS
    This is an implementation of the timer_abstract.h interface.  It is very
    simple and uses only one thread which is always alive in a timer_heavy.
    The reason this object exists is for historical reasons.  Originally, the
    dlib::timer was a multi-implementation component and the timer_heavy was
    its first implementation.  It was superseded later by the more efficient
    dlib::timer.  However, timer_heavy is still around so that
    dlib::timer::kernel_1a has something to refer to.  This way, old client
    code which somehow depends on the same thread always calling a timer action
    function isn't going to be disrupted.


INITIAL VALUE
    - running   == false
    - delay     == 1000
    - ao        == a pointer to the action_object()
    - af        == a pointer to the action_function()
    - m         == a mutex that locks everything in this class
    - s         == a signaler for mutex m
    - stop_running == false

CONVENTION
    - running &amp;&amp; !stop_running == is_running()
    - delay == delay_time()
    - *ao == action_object()
    - af == action_function()    

    - if (running) then
        - there is a thread running
    - if (is_running()) then
        - next_time_to_run == the time when the next execution of the action
          function should occurr.  (the time is given by ts.get_timestamp())

    - stop_running is used to tell the thread to quit.  If it is
      set to true then the thread should end.
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="ab4a92bd402f4da20fde17233ce8a75e7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab4a92bd402f4da20fde17233ce8a75e7">&#9670;&nbsp;</a></span>ao</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T&amp; <a class="el" href="classdlib_1_1timer__heavy.html">dlib::timer_heavy</a>&lt; T &gt;::ao</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - is run in its own thread
ensures
    - calls the action function for the given timer object in the manner
      specified by timer_kernel_abstract.h
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="timer__heavy_8h_source.html">timer_heavy.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
